<?php

namespace App\Controller\Admin;

use App\Enum\Role;
use App\Entity\Size;
use App\Entity\Extra;
use App\Entity\UserAddress;
use App\Traits\LanguagesTrait;
use App\Entity\RestaurantCategory;
use App\Controller\Admin\CrudController;
use Doctrine\ORM\EntityManagerInterface;
use App\Controller\Admin\Field\VichImageField;
use App\Controller\Admin\Filter\IdExtraFilter;
use EasyCorp\Bundle\EasyAdminBundle\Config\Crud;
use EasyCorp\Bundle\EasyAdminBundle\Config\Action;
use EasyCorp\Bundle\EasyAdminBundle\Config\Assets;
use EasyCorp\Bundle\EasyAdminBundle\Config\Actions;
use EasyCorp\Bundle\EasyAdminBundle\Config\Filters;
use EasyCorp\Bundle\EasyAdminBundle\Field\FormField;
use EasyCorp\Bundle\EasyAdminBundle\Field\TextField;
use EasyCorp\Bundle\EasyAdminBundle\Field\ChoiceField;
use EasyCorp\Bundle\EasyAdminBundle\Field\NumberField;
use Symfony\Contracts\Translation\TranslatorInterface;
use EasyCorp\Bundle\EasyAdminBundle\Field\BooleanField;
use EasyCorp\Bundle\EasyAdminBundle\Filter\ChoiceFilter;
use EasyCorp\Bundle\EasyAdminBundle\Context\AdminContext;
use EasyCorp\Bundle\EasyAdminBundle\Field\AssociationField;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use EasyCorp\Bundle\EasyAdminBundle\Router\AdminUrlGenerator;
use Symfony\Component\Validator\Validator\ValidatorInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use EasyCorp\Bundle\EasyAdminBundle\Provider\AdminContextProvider;
use Symfony\Component\PasswordHasher\Hasher\UserPasswordHasherInterface;
use Symfony\Component\Security\Core\Encoder\UserPasswordEncoderInterface;
use Symfony\Component\DependencyInjection\ParameterBag\ParameterBagInterface;

class ExtraCrudController extends CrudController
{
    use LanguagesTrait;

    public function __construct (ParameterBagInterface $params, EntityManagerInterface $em,
                                 AdminContextProvider $context, ValidatorInterface $validator,
                                 TranslatorInterface $translator, AdminUrlGenerator $adminUrlGenerator,
                                 UserPasswordHasherInterface $userPasswordHasher)
    {
        parent::__construct($params, $em, $context, $validator, $translator, $adminUrlGenerator);
    }

    public static function getEntityFqcn (): string
    {
        return Extra::class;
    }

    public function configureAssets(Assets $assets): Assets
    {
        return $assets
            ->addJsFile('https://code.jquery.com/jquery-3.6.1.min.js')
            ->addJsFile('adminJs/hideMenuApp.js')
        ;
    }

    public function configureCrud (Crud $crud): Crud
    {
        return $crud
            ->setEntityLabelInSingular($this->trans('extra.labelInSingular'))
            ->setEntityLabelInPlural($this->trans('extra.labelInPlural'))
            ->setSearchFields(['name'])
            ;
    }

    public function configureFilters(Filters $filters): Filters
    {
        return $filters
            ->add(IdExtraFilter::new('id')
                ->setLabel($this->trans('extra.configureFields.idExtraType')))
        ;
    }

    public function configureActions (Actions $actions): Actions
    {
        return $actions
            ->add(Crud::PAGE_INDEX, Action::DETAIL);
    }

    public function configureFields (string $pageName): iterable
    {
        $name = TextField::new('name')
            ->setLabel($this->trans('extra.configureFields.name'))
            ->setColumns('col-md-6 col-xl-3')
            ->setRequired(true)
        ;

        $pvp =  NumberField::new('pvp')
            ->setLabel($this->trans('extra.configureFields.pvp'))
            ->setNumDecimals(2)
            ->setColumns('col-md-3 col-xl-3')
            ->setRequired(true)
        ;

        $extraType =  AssociationField::new('extraType')
            ->setFormTypeOption('choice_label', 'title')
            ->setLabel($this->trans('extra.configureFields.extraType'))
            ->renderAsNativeWidget()
        ;

        $isActive = BooleanField::new('isActive')
            ->setLabel($this->trans('menu.configureFields.isActive'))
            ->setColumns('col-md-3 col-xl-3')
        ;

        if (in_array($pageName, [Crud::PAGE_INDEX]))
        {
            return [$name, $pvp, $extraType, $isActive];
        }
        else if (in_array($pageName, [Crud::PAGE_NEW, Crud::PAGE_EDIT, Crud::PAGE_DETAIL]))
        {
            return [
                $name,
                $pvp,
                $isActive,
                $extraType
            ];
        }

        return [];
    }

}
